drop table  new_books;
drop table  new_journals ;
drop table  Author ;
drop table  claim ;
drop table  issue ;
drop table  J_issue ;

drop table Fine_Details ;
drop table Users ;
drop table Userclass ;
drop table Journal ;
drop table  shelved_books ;
drop table Books ;
drop table libstaff;
drop table grp;

create table Books
(  constraint Pk_Books  primary key (Acc_num),
   Acc_num integer not null,
   ISBN    varchar(20),
   Publisher varchar(50),
   Book_name varchar(100),
   Class_num varchar(20),
   Edition varchar(2),
   Obtained_from varchar(50),
   ValueI varchar(1) ,
   ValueC varchar(1) ,
   ValueL varchar(1) ,
   Price   numeric(10,2) );

create table Journal
(
 constraint Pk_Journal primary key(JAcc_num),
 JAcc_num integer not null,
 JISBN    integer , 
 Journal_name varchar(100),
 JClass_num varchar(10),
 Journal_date  date ,
 Journal_cost numeric(10,2), 
 notify_addr varchar(100),
 expiry_date  date ,
 frequency   varchar(13),
 JvalueI char(1),
 JvalueL char(1) ) ;   

create table Author 
(
 Constraint Pk_Author primary key(ISBN,AuthorName),
 ISBN  varchar(20) not null,
 AuthorName varchar(20) not null
);

create table Userclass
(    
 constraint  Pk_UserClass primary key(category),
 category varchar(10) ,
 books_allowed smallint ,
 journals_allowed smallint,
 duration  smallint, 
 claims_allowed smallint ) ;

create table Users
(
 constraint Pk_Users primary key(user_id),
 user_id    varchar(10) not null,
 category varchar(10),
 foreign key(category) references userclass, 
 user_name  varchar(50),
 user_dept  varchar(10),
 user_email varchar(40),
 activation char(1)) ;


create table Fine_Details
(
 constraint Pk_Fines primary key(user_id, acc_num, due_date),
 user_id      varchar(10) not null ,
 acc_num      integer not null,
 due_date     date not null,
 return_date  date,
 fine_tot     numeric(5,2),
 paid         char(1) ) ; 




create table issue
( 
 acc_num    integer,
 user_id    varchar(10),
 issue_date date,
 category varchar(10),
 fine         numeric(5,2),
 primary key(acc_num),
 foreign key(user_id) references Users,
 foreign key(category) references Userclass,
 foreign key(acc_num) references Books );

create table claim 
( 
 acc_num     integer,
 user_id     varchar(10),
 claim_no    smallint,
 foreign key(acc_num) references books, 
 primary key(user_id, acc_num),
 foreign key(user_id) references Users);

create table shelved_books
(
 acc_num integer not null,
 Book_name varchar(30) not null,
 Edition   varchar(2) ,
 claim_start  date not null,
 claim_no    smallint,
 foreign key (acc_num) references Books );



create table J_issue
(
 jacc_num     integer,
 user_id     varchar(10),
 issue_date  date,
 category    varchar(10),
 fine          numeric(5,2) ,  
 primary key(user_id,jacc_num),
 foreign key(category) references Userclass,
 foreign key(user_id) references Users,
 foreign key(jacc_num) references Journal);


create table new_journals
(
 constraint Pk_newjournals primary key(Journal_name, Journal_date),
 Journal_name varchar(100),
 Journal_date  date ,
 notify_addr varchar(100),
 frequency   varchar(13),
 Jdetails varchar(100), 
 Journal_cost numeric(10,2) 
); 

create table new_books	
(  
 constraint Pk_newBooks  primary key (Book_name, Author_name, Edition),
 Publisher varchar(50),
 Book_name varchar(30),
 Author_Name varchar(30),
 Edition varchar(2),
 details varchar(100),
 Price   numeric(10,2) );

---added after
--create table grp(
    --  constraint Pk_group primary key(group_id),
    --   group_id varchar(10),
    --  sel char(1),
    --  updat char(1),
    --   ins char(1),
    --  del char(1),
    -- time_out date);
create table grp(
    constraint Pk_group primary key(group_id),
    group_id varchar(20),
    IssueB char(1),
    ReturnB char(1),
    RemoveC char(1),
    AddB char(1),
    DelB char(1),
    EditB char(1),
    IssueJ char(1),
    ReturnJ char(1),
    AddJ  char(1),
    DelJ  char(1),
    EditJ char(1),
    AddU char(1),
    DelU char(1),
    EditU  char(1),
    AddUC char(1),
    DelUC  char(1),
    EditUC char(1),
    AddS   char(1),
    DelS   char(1),
    EditS char(1),
    AddG   char(1),
    DelG   char(1),
    EditG char(1),
    time_out date);

    create table libstaff
    (constraint Pk_libstaff primary key(staff_id),
     staff_name varchar(50),
     staff_id varchar(30) not null,
     passwd varchar(30) not null,
     group_id references grp(group_id),
     active char(1));
